/*

  The Kitchen - Jaime Vives Piqueres 2004-2005

  Entry for the POVCOMP 2004

  i_apples.inc : apple textures from my fruit texturing trick

*/

// *** random seeds ***
#declare r1=seed(930);  // apple seed
#declare r_l=seed(1003);  // light pos. seed


// *** fuji apple colors, pigments and textures ***
// basic pigments
#declare p1=Firebrick*.8+Red*.2;
#declare p3=Yellow*.8+White*.1;
#declare p2=ForestGreen*.8+White*.1;
// base texture (bottom layer)
#declare t_base=
texture{
 pigment{
  cylindrical
  turbulence .25
  color_map{
   [0.0 p1]
   [0.2 p1]
   [0.7 p3]
   [1.0 p2]
  }
  scale 5
  translate 1
 }
}
// pgment for the radial-slope texture ("stripes", second layer)
#declare p_stripes=
pigment{
 pigment_pattern{
  bumps
  turbulence .5
  lambda 2.5
  scale <1,7,1>*.15
 }
 color_map{
  [0.0 p1]
  [0.45 p1]
  [0.45 p1 transmit .9]
  [1.0 p1 transmit .9]
 }
}
// *** "soft/hide" texture (third layer), with additional "dirty" layer ***
#declare t_upper=
texture{
 pigment{
  cylindrical
  turbulence .25
  color_map{
   [0.0 p1 transmit .8]
   [0.2 p1 transmit .6]
   [0.7 p3 transmit .1]
   [1.0 p3 transmit .0]
  }
  scale 4
  translate 1
 }
} 
texture{
 pigment{
  granite
  turbulence .5
  lambda 3
  color_map{
   [0.00 DarkGreen*.5 transmit .1]
   [0.1 DarkTan transmit .5]
   [0.20 DarkGreen transmit .8]
   [1.00 DarkTan transmit .9]
  }
 }
 normal{
  granite .1
  turbulence .5
  lambda 3
  scale .01
 }
 finish{
  phong .3 phong_size 20 
  reflection {.025,.1}
 }
 scale 4
}

// *** create the final texture ***
#include "i_fruitext.inc"  // fruit texturing macros
#if (use_textures)
#declare t_apple=m_radial_sloped(t_base,p_stripes,t_upper,r1)
#else
#declare t_apple=texture{pigment{Pink}}
#end


