/*

  The Kitchen - Jaime Vives Piqueres 2004-2005

  Entry for the POVCOMP 2004

  i_can.inc : a beer can

*/

/* +++ control +++ */
#declare pruebas=0;

/* +++ medidas +++ */
#declare alto_lata=11.7;
#declare alto_etq=9.2;
#declare diam_lata=6.5;
#declare diam_sup=5.7;
#declare diam_inf=5.7;
#declare rad_lata=diam_lata/2;
#declare rad_sup=diam_sup/2;
#declare rad_inf=diam_inf/2;
#declare perimetro=2*3.141516*rad_lata;
#declare refl_lata=0.1;


/* +++ tapa superior de la lata , con el "abre-facil" por acabar +++ */
#declare parte_sup=
difference{
 union{
  intersection{
   superellipsoid{
   <1,0.1>
   rotate 90*x
   scale <rad_sup,0.1,rad_sup>
   }
   cylinder{
    <0,-1.1,0>
    <0,1.1,0>
    rad_lata-0.1
   }
  }
  intersection{
   sphere{
    <0,0,0>
    rad_lata-0.3
    scale <1,0.2,1>
    translate -0.2*y
   }
   plane{y,0 inverse}
   sphere{
    <0,0,0>
    rad_lata-0.3
    scale <1,0.2,1>
    scale 0.9
    translate -0.2*y
   }
  }
 }
 cylinder{
  <rad_lata/2,-10,0>
  <rad_lata/2,10,0>
  rad_lata/3
  scale <0.9,1,0.7>
 }
}

/* +++ cuerpo principal de la lata +++ */
#declare cuerpo =
sor{
10
 <rad_inf,-1>
 <rad_inf,0>
 <rad_inf+0.1,0.2>
 <rad_lata-0.1,0.6>
 <rad_lata,0.8>
 <rad_lata,10>
 <rad_lata-0.1,10.2>
 <rad_sup,11.1>
 <rad_sup-0.1,11.6>
 <rad_sup-0.1,12>
 open
}

/* +++ fondo de la lata +++ */
#declare parte_inf=
superellipsoid{
 <1,0.1>
 rotate 90*x
 scale <rad_sup-0.01,0.1,rad_sup-0.01>
}

/* +++ superficie de reposo +++ */
box{<-10,-1,-10>,<10,0,10>
 hollow
 texture{t_aluminum}
}

/* +++ composicion +++ */
#declare lata =
union
{
 object{parte_sup
  texture{
   t_aluminum
   normal{bumps 0.07 scale 4}
  }
  translate (alto_lata-0.1)*y
 }
 object{parte_inf
  texture{
   t_aluminum
   normal{bumps 0.07 scale 4}
  }
 }
 object{cuerpo
  texture{t_can
   translate <-0.5,-0.5,0>
   scale <rad_lata,alto_lata*.95,rad_lata>
   translate alto_lata/2*y
  }
 }
 clipped_by{
  cylinder{<0,-1,0>,<0,alto_lata+.1,0>,rad_lata+.1}
 }
}

