/*

  The Kitchen - Jaime Vives Piqueres 2004-2005

  Entry for the POVCOMP 2004

  i_furniture.inc : assemblling all the kitchen furniture 

*/

#include "i_sink.inc"
#include "i_faucet.inc"
#include "i_shelfsp.inc"
#include "i_cab_door.inc"
#include "i_drawer.inc"
#declare r_wood=seed(96378);
#if (use_radiosity=2)
#declare woodboard1=box{-.5,.5}
#declare woodboard2=box{-.5,.5}
#declare woodboard3=box{-.5,.5}
#else
#declare woodboard1=
superellipsoid{<.02,.2> rotate 90*x scale .5}
#declare woodboard2=
superellipsoid{<.1,.05> rotate 90*x scale .5}
#declare woodboard3=
superellipsoid{<.1,.01> rotate 90*x scale .5}
#end
#declare tirador=
union{
 superellipsoid{<.1,1> rotate 90*y scale <1,1,8> translate -.5*x}
 cylinder{<-.5,0,5>,<2,0,5>,1}
 cylinder{<-.5,0,-5>,<2,0,-5>,1}
 texture{t_chrome}
}
#declare shelves=
union{
 object{woodboard1
  scale <30,3,80>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-15,0,0>
 }
 object{woodboard1
  scale <3,10,70>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-1.5,-5,0>
 }
 union{
  cylinder{<0,0,0>,<-5,0,0>,.25}
  cylinder{<-5,0,0>,<-5,1,0>,.25}
  texture{t_chrome}
  translate <-1.5,-6,26>
 }
 union{
  cylinder{<0,0,0>,<-5,0,0>,.25}
  cylinder{<-5,0,0>,<-5,1,0>,.25}
  texture{t_chrome}
  translate <-1.5,-6,6>
 }
 union{
  cylinder{<0,0,0>,<-5,0,0>,.25}
  cylinder{<-5,0,0>,<-5,1,0>,.25}
  texture{t_chrome}
  translate <-1.5,-6,-14>
 }
 union{
  cylinder{<0,0,0>,<-5,0,0>,.25}
  cylinder{<-5,0,0>,<-5,1,0>,.25}
  texture{t_chrome}
  translate <-1.5,-6,-34>
 }
 object{shelfsp scale <10,10,20> rotate -90*y
  translate <-10,-10,35>
 }
 object{shelfsp scale <10,10,20> rotate -90*y
  translate <-10,-10,-35>
 }
}

#declare sink_bench=
union{
 // lower parts
 // counter top
 intersection{
  object{woodboard1
   scale <60,4,200>
  }
  plane{x,-20}
  texture{t_marble}
  translate <-30,89.5,0>
 }
 intersection{
  object{woodboard1
   scale <60,4,200>
  }
  plane{z,1}
  texture{t_marble}
  translate <-30,89.5,-50>
 }
 intersection{
  object{woodboard1
   scale <60,4,200>
  }
  plane{z,-2 inverse}
  texture{t_marble}
  translate <-30,89.5,53>
 } 
 object{woodboard1
  scale <50,4,60>
  texture{t_marble}
  translate <-75,89.5,120>
 }
 object{woodboard1
  scale <116,4,60>
  texture{t_marble}
  translate <-58-100-84,89.5,120> 
 }
 // wood sides
 box{-.5,.5
  scale <58,89,1>
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-29,89*.5,99>
 }
 box{-.5,.5
  scale <58,89,1>
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-29,89*.5,48>
 }
 box{-.5,.5
  scale <58,89,1>
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-29,89*.5,-48>
 }
 box{-.5,.5
  scale <58,89,1>
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-29,89*.5,-100>
 }
 box{-.5,.5
  scale <58,89,1>
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-29,89*.5,-100-49.5>
 }
 box{-.5,.5
  scale <1,89,58>
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-99,89*.5,127>
 }
 box{-.5,.5
  scale <1,89,58>
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-100-84.5,89*.5,127>
 }
 box{-.5,.5
  scale <1,89,58>
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-100-84-50,89*.5,127>
 }
 // cajones
 object{drawer(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  translate <-58,90-3-15*.5,-74-50>
 }
 object{drawer(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  translate <-58,90-3-15*.5-1-15,-74-50>
 }
 object{drawer(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  translate <-58,90-3-15*.5-1-15-1-15,-74-50>
 }
 object{drawer(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  translate <-59.9,90-3-15*.5-1-15-1-15-1-15,-74-50>
 }
 object{drawer(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  translate <-58,90-3-15*.5-1-15-1-15-1-15-1-15,-74-50>
 }
 // puertas
 object{cab_door(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  translate <-58,47,-24.5>
 }
 union{
  object{cab_door(texture{t_wood_furn translate 1000*rand(r_wood)*z})}
  object{tirador rotate 90*x translate <-2,23,-22>}
  translate -24*z rotate 25*y translate 24*z
  translate <-58,47,24.5>
 }
 object{cab_door(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  translate <-58,47,-74>
 }
 object{cab_door(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  scale <1,1,4/5>
  translate <-58,47,74-5>
 }
 object{cab_door(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  scale <1,1,4/5> 
  rotate -90*y
  translate <-80,47,102-10>
 }
 object{cab_door(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  rotate -90*y
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-75-84-50,47,102-10>
 }
 object{woodboard3
  scale <48+16,80,2>
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-75-84-50-50-8,47,102-10>
 }
 // tiradores cajones
 object{tirador translate <-60,90-2-15*.5,-74-51>}
 object{tirador translate <-60,90-2-15*.5-1-15,-74-51>}
 object{tirador translate <-60,90-2-15*.5-1-15-1-15,-74-51>}
 object{tirador translate <-60,90-2-15*.5-1-15-1-15-1-15,-74-51>}
 // tiradores puertas
 object{tirador rotate 90*x translate <-60,100-30,-24.5+22>}
 object{tirador rotate 90*x translate <-60,100-30,-74-22>}
 object{tirador rotate 90*x translate <-60,100-30,74-22>}
 object{tirador rotate 90*x rotate -90*y translate <-75-22,100-30,90>}
 object{tirador rotate 90*x rotate -90*y translate <-75+19-84-50,100-30,90>}
 object{tirador rotate 90*x rotate -90*y translate <-75+29-84-50-58,100-30,90>}
 // soportes y baldas
 box{-.5,.5
  scale <1,8,50>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-57,4,-25>
 }
 box{-.5,.5
  scale <1,6,50>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-57,90-3,-25>
 }
 box{-.5,.5
  scale <54,2,100>
  texture{t_wood_furn rotate 90*y translate 1000*rand(r_wood)*z}
  translate <-30,4,0>
 }
 box{-.5,.5
  scale <54,2,100>
  texture{t_wood_furn rotate 90*y translate 1000*rand(r_wood)*z}
  translate <-30,40,0>
 }
 box{-.5,.5
  scale <1,8,50>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-57,4,25>
 }
 box{-.5,.5
  scale <1,6,50>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-57,90-3,25>
 }
 box{-.5,.5
  scale <1,8,50>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-57,4,-74>
 }
 box{-.5,.5
  scale <1,8,50>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-57,90-4,-74>
 }
 box{-.5,.5
  scale <1,8,50>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-57,4,-74-50>
 }
 box{-.5,.5
  scale <1,8,50>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-57,90-4,-74-50>
 }
 box{-.5,.5
  scale <1,8,40>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-57,4,74-5>
 }
 box{-.5,.5
  scale <1,8,50>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-57,90-4,74>
 }
 difference{
  box{-.5,.5 scale <4,90,4>}
  box{-.5,.5 scale <4,91,4> translate <-1,0,-1>}
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-58.5,45,102-10>
 }
 box{-.5,.5
  scale <50,8,1>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-75,4,103.5-10>
 }
 box{-.5,.5
  scale <50,8,1>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-75,90-4,103.5-10>
 }
 box{-.5,.5
  scale <50,8,1>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-75-84-50,4,103.5-10>
 }
 box{-.5,.5
  scale <50+16,8,1>
  texture{t_wood_furn translate 1000*rand(r_wood)*z}
  translate <-75-84-50-58,4,103.5-10>
 }
 // fregadero
 object{
  fregadero(t_steel)
  scale 100
  translate <1,91.5,0>
 }
 object{faucet scale 4.5
  rotate 90*y
  translate <-6,90.5,0>
 }
 // uper parts
 // baldas
 object{woodboard1
  scale <100,3,52>
  texture{t_wood_furn rotate 90*y translate 1000*rand(r_wood)*z}
  translate <-50,160,125>
 }
 object{woodboard1
  scale <100,3,52>
  texture{t_wood_furn rotate 90*y translate 1000*rand(r_wood)*z}
  translate <-50,160+80,125>
 }
 object{woodboard1
  scale <84,3,60>
  texture{t_wood_furn rotate 90*y translate 1000*rand(r_wood)*z}
  translate <-142.1,180,115>
 }
 object{woodboard1
  scale <84,3,42>
  texture{t_wood_furn rotate 90*y translate 1000*rand(r_wood)*z}
  translate <-142.1,160+80,135>
 }
 object{woodboard1
  scale <116,3,52>
  texture{t_wood_furn rotate 90*y translate 1000*rand(r_wood)*z}
  translate <-142-42-58,160,125>
 }
 // puertas
 object{cab_door(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  rotate -90*y
  translate <-74.5,200,102>
 }
 object{tirador rotate 90*x rotate -90*y translate <-75+22,160+17,100>}
 object{cab_door(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  rotate -90*y
  translate <-25.5,200,102>
 }
 object{tirador rotate 90*x rotate -90*y translate <-75-22+50,160+17,100>}
 object{cab_door(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  rotate -90*y
  translate <-74.5-84-48-3.5,200,102>
 }
 object{tirador rotate 90*x rotate -90*y translate <-75-22-84-50,160+17,100>}
 object{woodboard3
  scale <48+16,79,2>
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-74.5-84-48-3.5-48-1-8,200,102>
 }
 object{tirador rotate 90*x rotate -90*y translate <-75-84-50-48-16+34.5,160+17,100>}
 // tapas
 box{-.5,.5
  scale <1,79,48>
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-99,200,127>
 }
 object{cab_door(texture{t_wood_furn translate 1000*rand(r_wood)*z})
  rotate -90*y
  rotate 90*z
  scale <11/10,6/5,1>
  rotate 15*x
  translate <-142,210,110>
 }
 box{-.5,.5
  scale <1,79,48>
  texture{t_wood_furn rotate 90*x translate 1000*rand(r_wood)*y}
  translate <-185,200,127>
 }
 // shelves
 object{shelves translate <0,160,-110>}
 object{shelves translate <0,190,-110>}
 object{shelves rotate 180*y translate <-room_width,160,-25>}
 object{shelves rotate 180*y translate <-room_width,160,-80-50>}
 object{shelves rotate 180*y translate <-room_width,190,-25>}
 object{shelves rotate 180*y translate <-room_width,190,-80-50>}
}

