/*

  The Kitchen - Jaime Vives Piqueres 2004-2005

  Entry for the POVCOMP 2004

  i_kitchen.inc: a typical cheap kitchen

*/

// gas fire
#declare t_flame=
texture{
 pigment{rgbt 1}
}
#include "i_flame.inc"
#declare ifl=0;
#declare nfl=18;
#declare fire=
union{
#while (ifl<nfl)
 object{mesh_flame hollow
  interior{
   media{
    emission 1
    density{
     planar
     density_map{
      [0 Blue*.75+Green*.25]
      [1 Red]
     }
     scale .5
     translate .1*y
    }
   }
  }
  rotate 5*x
  translate 5*z
  rotate ifl*(360/nfl)*y
 }
 #declare ifl=ifl+1;
#end
}
// fogones
#declare fogon_grande=
union{
 cylinder{<0,0,0>,<0,-1,0>,5
  texture{t_chrome}
 }
 superellipsoid{<1,.75> rotate 90*x scale <5,1,5>
  texture{
    pigment{Gray*.1} 
    #if (use_textures)
    finish{Phong_Glossy}
    #end
  }
 }
}
#declare fogon_peque=
union{
 cylinder{<0,0,0>,<0,-1,0>,3
  texture{t_chrome}
 }
 superellipsoid{<1,.75> rotate 90*x scale <3,1,3>
  texture{
    pigment{Gray*.1} 
    #if (use_textures)
    finish{Phong_Glossy}
    #end
  }
 }
 #if (use_textures)
 object{fire scale <.6,1,.6>}
 #end
}
#declare cocina=
union{
 // + mueble +
 difference{
  superellipsoid{
   <.1,.01>
   rotate 90*x
   scale <40,25,32.5>
   translate -5*y
  }
  box{
   <-30,-24,-100>
   < 30, 10, 30>
  }
  translate 10*y
  texture{t_color2
   normal{bumps 0.1 scale 16}
  }
 }
 #if (use_glass)
 box{
  <-30,-24,-.5>
  < 30, 10, .5>
  texture{Glass normal{bumps .025 scale 14}}
  translate <0,10,-32>
 }
 #end
 union{
  cylinder{<-30,-24,0>,<30,-24,0>,1}
  cylinder{<-30,10,0>,<30,10,0>,1}
  cylinder{<-30,10,0>,<-30,-24,0>,1}
  cylinder{<30,10,0>,<30,-24,0>,1}
  texture{t_chrome}
  translate <0,10,-32>
 }
 difference{
  superellipsoid{<.2,.8> scale <3,2,28>}
  cylinder{-2.1*y,2.1*y,1 scale <3,2,28>*.8}
  rotate 90*y
  texture{t_chrome normal{bumps scale 6}}
  translate <0,26,-32>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <40,10,32.5>
  texture{t_color2
     normal{bumps 0.1 scale 16 translate 50*rand(r_coc)}
  }
  translate -30*y
 }
 superellipsoid{
  <.1,.025>
  rotate 90*x
  scale <40,5,32.5>
  texture{
   pigment{image_map{jpeg "cocina-frontal.jpg"}}
   #if (use_textures)
   finish{Glossy}
   #end
   translate -.5
   scale <80,10,1>
   translate <7.5,-.3,0>
  }
  translate (30+5.2)*y
  #if (use_textures) texture{t_kdirty} #end
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <40,2.5,32.5>
  texture{t_color1
      normal{bumps 0.1 scale 16 translate 50*rand(r_coc)}
  }
  translate (-30-2.4-10)*y
 }
 // tapa superior
 difference{
  superellipsoid{<.1,.1> rotate 90*x}
  superellipsoid{<.05,.05> rotate 90*x scale .95 translate .95*y}
  scale <40,2,32.5>
  texture{
      t_chrome
      normal{bumps 0.1 scale 16 translate 50*rand(r_coc)}
  }
  translate (30+10+2)*y
 }
 difference{
  superellipsoid{
   <.1,.1>
   rotate 90*x
   scale <40,2,32.5>
   rotate 90*x
  }
  superellipsoid{
   <.1,.1>
   rotate 90*x
   scale <40,2,32.5>
   rotate 90*x
   scale 0.99
  }
  plane{z,-0.85}
  texture{t_color2
      normal{bumps 0.1 scale 16 translate 50*rand(r_coc)}
  }
  rotate 2*x
  translate <0,(30+10+2+32.5+1),32.5>
 }
 // + marca (balray) +
 height_field{
  png "hf_blray"
  translate -.5
  rotate -90*x
  texture{
   material_map{
    png "mm_blray"
    texture{pigment{Clear}}
    texture{pigment{White} finish{Shiny reflection 0.1}}
    texture{t_chrome}
    texture{Bronze_Texture}
   }
   translate -.5
  }
  scale <15,3.2,.5>
  translate <25,-25,-32.70>
 }
 // + mandos +
 union{
  superellipsoid{<1,.1> scale .5 scale <5,5,1>}
  superellipsoid{<.1,.5> rotate 90*z scale .5 scale <1.5,5,2>}
  translate <0,30+5,-33>
  texture{t_color2}
  #if (use_textures) texture{t_kdirty} #end
 }
 union{
  superellipsoid{<1,.1> scale .5 scale <5,5,1>}
  superellipsoid{<.1,.5> rotate 90*z scale .5 scale <1.5,5,2>}
  translate <-12,30+5,-33>
  texture{t_color2}
  #if (use_textures) texture{t_kdirty} #end
 }
 union{
  superellipsoid{<1,.1> scale .5 scale <5,5,1>}
  superellipsoid{<.1,.5> rotate 90*z scale .5 scale <1.5,5,2>}
  translate <12,30+5,-33>
  texture{t_color2}
  #if (use_textures) texture{t_kdirty} #end
 }
 union{
  superellipsoid{<1,.1> scale .5 scale <5,5,1>}
  superellipsoid{<.1,.5> rotate 90*z scale .5 scale <1.5,5,2>}
  translate <24,30+5,-33>
  texture{t_color2}
  #if (use_textures) texture{t_kdirty} #end
 }
 union{
  superellipsoid{<1,.1> scale .5 scale <5,5,1>}
  superellipsoid{<.1,.5> rotate 90*z scale .5 scale <1.5,5,2>}
  translate <-24,30+5,-33>
  texture{t_color2}
  #if (use_textures) texture{t_kdirty} #end
 }
 // * rejilla protectora *
 height_field{
  png "hf_fogon"
  water_level .2
  translate -.5
  scale <78*.97,2,65*.96>
  texture{
   pigment{Gray10*.1} 
   #if (use_textures)
   finish{Phong_Glossy}
   #end
  }
  translate <0,44,0>
 }
 // * fogones *
 union{
  object{fogon_grande translate <-19,0,-16>}
  object{fogon_grande translate < 19,0,-16>}
  object{fogon_peque translate <-19,0, 16>}
  object{fogon_peque translate < 19,0, 16>}
  translate 43*y
 }
}

#include "i_extractor.inc"
#declare kitchen_extractor=
union{
 union{
  difference{
   superellipsoid{<.01,.1> rotate 90*x scale .5
    scale <80,6,60>
   }
   box{-.5,.5 scale <8,3,1> translate <10,0,-30>}
   box{-.5,.5 scale <8,3,1> translate <20,0,-30>}
   box{-.5,.5 scale <3,3,1> translate <30,0,-30>}
  }
  superellipsoid{<.1,.1> rotate 90*x scale .5
   scale <1,2,1> translate <10,0,-30>
  }
  superellipsoid{<.1,.1> rotate 90*x scale .5
   scale <1,2,1> translate <22,0,-30>
  }
  superellipsoid{<.1,1> rotate 90*x scale .5
   scale <1,2,1> translate <30,0,-30>
  }
  texture{t_white_plastic}
 }
 intersection{
  difference{
   box{-.5,.5 scale <80,10,60>}
   box{-.5,.5 scale <78,11,58>}
  }
  plane{z,0 inverse rotate -45*x translate -20*z}
  texture{t_white_plastic}
  translate -8*y
 }
 union{
  #if (use_glass)
  box{-.5,.5 scale <78,10,.5> texture{Glass}}
  #end
  cylinder{<39,-5,0>,<39,5,0>,.5 texture{t_white_plastic}}
  cylinder{<-38,-5,0>,<-39,5,0>,.5 texture{t_white_plastic}}
  translate <0,-8,-30>
 }
 object{
  extractor_grill
  rotate 180*y
  scale <95,70,60>
  translate <0,-7,-5>
 }
 #if (use_klight)
 object{
  Light(Blackbody(3200),2,9*x,9*z,4*use_area,4*use_area,0) 
  translate <0,-8,25>
 }
 #end
}
