/*

  The Kitchen - Jaime Vives Piqueres 2004-2005

  Entry for the POVCOMP 2004

  i_microwave.inc : a microwaves oven

*/

#declare t_mw_case=
texture{
 pigment{White}
 normal{bumps .05 scale 5}
 finish{Shiny reflection{0.01,0.2} ambient 0 diffuse 0.7}
}


#macro superelipsoide(resq)

#local tmp=(.5-resq);

merge{
 box{<-tmp,-tmp,-tmp>,<tmp,tmp,tmp>}
 box{<-tmp,-tmp,-.5>,<tmp,tmp,-tmp>}
 box{<-tmp,-tmp,tmp>,<tmp,tmp,.5>}
 box{<-.5,-tmp,-tmp>,<-tmp,tmp,tmp>}
 box{<tmp,-tmp,-tmp>,<.5,tmp,tmp>}
 box{<-tmp,-.5,-tmp>,<tmp,-tmp,tmp>}
 box{<-tmp,tmp,-tmp>,<tmp,.5,tmp>}
 cylinder{<-tmp,tmp,-tmp>,<tmp,tmp,-tmp>,resq}
 cylinder{<-tmp,-tmp,-tmp>,<tmp,-tmp,-tmp>,resq}
 cylinder{<-tmp,tmp,tmp>,<tmp,tmp,tmp>,resq}
 cylinder{<-tmp,-tmp,tmp>,<tmp,-tmp,tmp>,resq}
 cylinder{<tmp,tmp,-tmp>,<tmp,tmp,tmp>,resq}
 cylinder{<tmp,-tmp,-tmp>,<tmp,-tmp,tmp>,resq}
 cylinder{<-tmp,tmp,-tmp>,<-tmp,tmp,tmp>,resq}
 cylinder{<-tmp,-tmp,-tmp>,<-tmp,-tmp,tmp>,resq}
 cylinder{<-tmp,-tmp,-tmp>,<-tmp,tmp,-tmp>,resq}
 cylinder{< tmp,-tmp,-tmp>,< tmp,tmp,-tmp>,resq}
 cylinder{<-tmp,-tmp,-tmp>,<-tmp,tmp, tmp>,resq}
 cylinder{< tmp,-tmp,-tmp>,< tmp,tmp, tmp>,resq}
 sphere{0,resq translate <-tmp,tmp,-tmp>}
 sphere{0,resq translate <-tmp,tmp, tmp>}
 sphere{0,resq translate < tmp,tmp,-tmp>}
 sphere{0,resq translate < tmp,tmp, tmp>}
 sphere{0,resq translate <-tmp,-tmp,-tmp>}
 sphere{0,resq translate <-tmp,-tmp, tmp>}
 sphere{0,resq translate < tmp,-tmp,-tmp>}
 sphere{0,resq translate < tmp,-tmp, tmp>}
}

//box{-.5,.5}
#end


#declare mw_case=
intersection{
 difference{
  object{superelipsoide(.025)}
  box{-.5,.5 scale <.7,.9,1> translate <-.1,0,-.1>}
  scale <50,30,40>
 }
 plane{z,-17 inverse}
 texture{t_mw_case}
}
#declare mw_tap=
union{
 intersection{
  difference{
   object{superelipsoide(.025)}
   box{-.5,.5 scale <.6,.75,2> translate <-.1,0,0>}
   scale <50,30,40>
  }
  plane{z,-17}
  plane{x,13.9}
  texture{t_mw_case translate 1000}
 }
 #if (use_glass)
 box{-.5,.5 scale <.6,.75,.1> translate <-.1,0,0>
  scale <50,30,.1>
  texture{
   pigment{
    boxed
    color_map{
         [0.0 Black]
         [0.2 Clear]
         [1.0 Clear]
        }
   }
   scale .5
   scale <.6,.75,.1>
   scale <50,30,1>
   translate <-5,0,0>
  }
  texture{
   pigment{
    leopard
        color_map{
         [0.00 Black]
         [0.55 Gray10]
         [1.00 Gray10]
        }
    scale .1
   }
   normal{bumps 0.0125 scale 6}
   finish{Shiny reflection .1}
  }
  translate -19.9*z
 }
 #end
 text{
  ttf "cyrvetic" "Scallope 800" 1,0
  scale <2,1,.1>
  translate <-11,-13,-20.05>
  texture{pigment{Gray10} finish{reflection .1}}
 }
}
#declare trademark=
height_field{
 png "hf_pcmark"
 translate -.5
 rotate -90*x
}
#macro mw_control_wheel(wr)
union{
 difference{
  sphere{0,3}
  sphere{0,3 scale <1,2,1> translate <-3.5,0,-2>}
  sphere{0,3 scale <1,2,1> translate < 3.5,0,-2>}
  scale .98
  scale <1,1,.6>
  texture{t_mw_case}
  rotate wr*z
 }
 #declare nd=16;
 #declare i=0;
 union{
 #while (i<nd)
  sphere{0,.1 scale <1,1,.5> pigment{Red} translate <3.3,0,.2> rotate (150*i/nd)*z}
  #declare i=i+1;
 #end
  rotate -45*z
 }
}
#end
#declare mw_controls=
union{
 intersection{
  difference{
   object{superelipsoide(.025) scale <50,30,40>}
   box{-.5,.5 scale <7,3,2> translate <18,-11,-20>}
   sphere{0,3 translate <18.5,5,-20>}
   sphere{0,3 translate <18.5,-4,-20>}
  }
  plane{z,-17}
  plane{x,14.05 inverse}
  texture{t_mw_case translate 2000}
 }
 difference{
  object{superelipsoide(.025) scale .97 scale <7,3,2>}
  sphere{0,.8 scale <2,1,.25> rotate -5*y translate <1.5,0,-1>}
  texture{t_mw_case translate 3000}
  translate <18,-11,-19>
 }
 object{mw_control_wheel(0)
  translate <18.5,5,-20.2>
 }
 object{mw_control_wheel(-30)
  translate <18.5,-4,-20.2>
 }
 union{
  object{trademark
   scale <3,3,.2>
  }
  text{
   ttf "cyrvetic" "POV" 1,0
   scale <2,2,.1>
   translate 2*x
  }
  text{
   ttf "cyrvetic" "Wave" 1,0
   scale <1.8,1.8,.1>
   translate <2,-1.5,0>
  }
  translate <17,11.5,-20.05>
  texture{Chrome_Metal finish{ambient 0}}
 }
 union{
  text{
   ttf "cyrvetic" "POWER" 1,0
   scale <.8,.8,.1>
   translate <17.2,.5,-20.05>
  }
  text{
   ttf "cyrvetic" "TIME" 1,0
   scale <.8,.8,.1>
   translate <17.5,-8.5,-20.05>
  }
  texture{pigment{Red}
   finish{reflection .1}
  }
 }
}
#declare mw_interior=
union{
 box{-.5,.5
  scale <46,.1,36>
  texture{t_aluminum normal{quilted scale .4}}
 }
 cylinder{<0,-.2,0>,<0,.2,0>,12
  texture{pigment{checker color White color Gray10} scale 4 rotate y*45}
  translate <-6,.5,0>
 }
}
#declare mw_recipe=
//sphere{0,5
sphere{0,6
 texture{Polished_Chrome finish{ambient 0}}
}


#declare jvp_microwave=
union{
/* object{
  Light(Blackbody(1500),100,<4,0,0>,<0,0,1>,4*use_area,1*use_area,0)
  translate 13*y
 }
*/
 object{mw_case}
 object{mw_tap translate -.1*z}
 object{mw_controls}
 object{mw_interior translate -12*y}
// object{mw_recipe translate <-7,-5,0> no_shadow}
}



