/*

  The Kitchen - Jaime Vives Piqueres 2004-2005

  Entry for the POVCOMP 2004

  i_plants.inc : pot with flowers

*/

// *** pots ***
#declare pot2=
union{
 difference{
  cone{<0,0,0>,7,<0,16,0>,10}
  cone{<0,1,0>,6,<0,17,0>,10}
 }
 difference{
  cone{<0,14,0>,10.4,<0,16,0>,10.5}
  cone{<0,13.5,0>,10.1,<0,16.5,0>,10.2}
 }
 pigment{Flesh*.25+Firebrick*.75}
 normal{granite .3 scale 1}
 #if (use_textures)
 finish{reflection{0,1 falloff 5}}
 #end
}

// *** achmea-like leaf ***
#macro achmea_leaf(lsize,lthick,lwidth)

intersection{
 difference{
  sphere{0,1 scale lsize}
  sphere{0,1 scale lsize-lthick}
 }
 plane{y,0 inverse}
 sphere{0,1 scale <lwidth,lsize*2+.1,lsize*2-.1> translate -lsize*z}
 translate (lsize+lwidth)*z
}

#end

// *** achema flower ***
#macro achmea_flor(rad_flor,t_caliz,t_estambres,t_petal,r_flor)
//sphere{0,4 pigment{Red} translate 4*y}
#local n_caliz=8;
#local n_petal=8;
#local caliz=
sphere{0,.5
 scale <1,2,.1>
 translate 1*y
 texture{t_caliz}
 rotate -45*x
}
#local petal=
sphere{0,.5
 scale <2,6,.1>
 rotate <-1+2*rand(r_flor),-1+2*rand(r_flor),-1+2*rand(r_flor)>
 translate 3*y
 texture{t_petal}
}

union{
 // caliz
 #local i_caliz=0;
 #while (i_caliz<n_caliz)
  object{caliz rotate (360*i_caliz/n_caliz)*y}
  #local i_caliz=i_caliz+1;
 #end
 // petalos
 #local i_petal=0;
 #while (i_petal<n_petal)
  object{petal
   scale 1.5
   rotate (-45-30*rand(r_flor))*x
   rotate (360*i_petal/n_petal)*y
   translate 1*y
  }
  object{petal
   scale 1.25
   rotate (-35-30*rand(r_flor))*x
   rotate -(360*i_petal/n_petal)*y
   rotate (360/n_petal)*.5*y
   translate 2*y
  }
  object{petal
   rotate (-25-30*rand(r_flor))*x
   rotate -(360*i_petal/n_petal)*y
   rotate (360/n_petal)*.5*y
   translate 3*y
  }
  #local i_petal=i_petal+1;
 #end
 sphere{0,1
  scale <1,.5,1>
  texture{t_estambres}
  translate 1.6*y
 }
}
#end

// *** achmea-like plant ***
#macro achmea_plant1(lsize,lthick,lwidth,nleafs,nchilds,t_leaf,rplant)

#local ichilds=0;
#local rp=seed(rplant);
#local lw=lwidth;
#local nl=nleafs;
#local t_est=
texture{
 pigment{Gold}
 normal{granite scale .1}
}
#local t_pet=
texture{
 pigment{Pink+Red*.1 filter 0.5}
 finish{metallic}
}

union{
#while (ichilds<nchilds)
 #local ileafs=0;
 #while (ileafs<nl)
  object{
   achmea_leaf(lsize,lthick,lw)
   scale (1-.5*(ichilds/nchilds))
   scale <1,1,.25+rand(rp)>
   texture{t_leaf}
   rotate -10*(sin(pi*ichilds/nchilds))*x
   rotate (360*(ileafs/nl)-5+10*rand(rp))*y
   translate lw*ichilds*y
  }
  #debug "."
  #local ileafs=ileafs+1;
 #end
 #local nl=nleafs*.5+nleafs*.5*(ichilds/nchilds);
 #local lw=lwidth*.5+lwidth*.5*(ichilds/nchilds);
 #local ichilds=ichilds+1;
#end
 object{
  achmea_flor(3+rand(rp),t_leaf,t_est,t_pet,rplant) rotate 360*rand(rp)*y
  translate (lw*ichilds+2)*y
 }
}

#end

#macro achmea_plant2(lsize,lthick,lwidth,nleafs,nchilds,t_leaf,rplant)

#local ichilds=0;
#local rp=seed(rplant);
#local lw=lwidth;
#local nl=nleafs;

union{
#while (ichilds<nchilds)
 #local ileafs=0;
 #while (ileafs<nl)
  object{
   achmea_leaf(lsize,lthick,lw)
   scale (1-.5*(ichilds/nchilds))
   scale <1,1,.25+rand(rp)>
   texture{t_leaf}
   rotate -10*(sin(pi*ichilds/nchilds))*x
   rotate (360*(ileafs/nl)-5+10*rand(rp))*y
   translate lw*ichilds*y
  }
  #debug "."
  #local ileafs=ileafs+1;
 #end
 #local lw=lwidth*.5+lwidth*.5*(ichilds/nchilds);
 #local ichilds=ichilds+1;
#end
}

#end

#macro hoja1(rleaf)
height_field{
 png "hf_hoja"
 water_level .1
 translate -.5
 rotate <-90,0,180>
 translate -.5*y
 scale <6,8,.2>
}
#end

#macro hoja2(rleaf)
height_field{
 png "hf_hoja2"
 water_level .1
 translate -.5
 rotate <-90,0,180>
 translate -.5*y
 scale <6,8,.5>
}
#end

#macro flor(rad_flor,t_caliz,t_estambres,t_petal,r_flor)
//sphere{0,4 pigment{Red} translate 4*y}
#local n_caliz=8;
#local n_petal=8;
#local caliz=
sphere{0,.5
 scale <1,2,.1>
 translate 1*y
 texture{t_caliz}
 rotate -45*x
}
#local petal=
sphere{0,.5
 scale <2,4,.1>
 rotate <-1+2*rand(r_flor),-1+2*rand(r_flor),-1+2*rand(r_flor)>
 translate 2*y
 texture{t_petal}
}

union{
 // caliz
 #local i_caliz=0;
 #while (i_caliz<n_caliz)
  object{caliz rotate (360*i_caliz/n_caliz)*y}
  #local i_caliz=i_caliz+1;
 #end
 // petalos
 #local i_petal=0;
 #while (i_petal<n_petal)
  object{petal
   rotate (-45-30*rand(r_flor))*x
   rotate (360*i_petal/n_petal)*y
   translate 1*y
  }
  #local i_petal=i_petal+1;
 #end
 sphere{0,1
  scale <1,.5,1>
  texture{t_estambres}
  translate 1.6*y
 }
}
#end

// *** HANGING PLANT 3 ***
#macro hanging_plant3(ntall,nnodo,radio,t_leaf,rplant)

 #local rp=seed(rplant);
 #local itall=0;
 #local t_est=
 texture{
  pigment{Gold}
  normal{granite scale .1}
  finish{ambient .01}
 }
 #local t_pet=
 texture{
  pigment{Violet+Red*.25+Blue*.25+Gray filter .3}
  finish{Phong_Dull ambient .01}
 }

 union{
 #while (itall<ntall)
  union{
  #local inodo=1;
  #local yant=0;
  #local zant=0;
  #local k=rand(rp);
  #while (inodo<=(nnodo*.75+nnodo*.25*rand(rp)))
   #local yact=+inodo;
   #local zact=-radio*.5*(sin(k*pi*(inodo/nnodo)));
   cylinder{<0,yant,zant>,<0,yact,zact>,.25
    texture{t_leaf}
   }
   #if (inodo>nnodo*.4 & (mod(inodo,2)=0))
    object{hoja2(rand(rp))
     scale <.5,(1.2-.4*sin(.5*pi*inodo/nnodo)),1>
     texture{t_leaf}
     rotate (30+30*rand(rp))*x
     rotate (4*360*inodo/nnodo)*y
     translate <0,yact,zact>
    }
   #end
   #local yant=yact;
   #local zant=zact;
   #local inodo=inodo+1;
  #end
   object{
    flor(3+rand(rp),t_leaf,t_est,t_pet,rplant) rotate 360*rand(rp)*y
    translate <0,yact,zact>
   }
   rotate (360*(itall/ntall)-10+20*rand(rp))*y
  }
  #local itall=itall+1;
 #end
 }

#end

#declare t_leaf4=
texture{
 pigment{
  bumps
  color_map{
   [0.0 Gray*.2+DarkGreen*.8 filter .2]
   [1.0 Green*.2+Gold*.5 filter .2]
  }
 }
 finish{Phong_Shiny ambient .01}
 scale 3
}

