/*

  The Kitchen - Jaime Vives Piqueres 2004-2005

  Entry for the POVCOMP 2004

  i_room.inc : kitchen room construction 

*/

#declare TILE_WARP_SIZE=5;
#declare TILE_WARP_ANGLE=22.5; //22.5, 30, 45, ..
#declare bc=c_tile_background;
#declare cs=c_tile_separator;
#declare f_test1=function{(sin(abs(x))+cos(abs(y)))}
#declare f_test2=function{(sin(abs(x))*cos(abs(y)))}
#declare f_test3=function{(sin(abs(x))+sin(abs(y)))}
#declare f_test4=function{(sin(x)-cos(y))}
#declare a_col1=array[1] {c_tile_blue}
#declare a_col1b=array[1] {c_tile_yellow}
#declare a_col1c=array[1] {c_tile_orange}
#declare a_col1d=array[1] {c_tile_green}
#declare a_col1t=array[1] {Clear}
#declare a_col2=array[2] {c_tile_blue,c_tile_yellow}
#declare a_col2b=array[2] {c_tile_green,c_tile_blue}
#declare a_col2c=array[2] {bc,c_tile_blue}
#declare a_col3=array[3] {c_tile_blue,c_tile_yellow,c_tile_green}
#declare a_col3b=array[3] {c_tile_blue,c_tile_orange,c_tile_green}
#declare p1=
pigment{
 p_tile( function{f_bozo(x+6,y+12,z)+f_test4(x+15.5,y+5,z)+f_test1(x,y,z)}, bc, cs, a_col2c, .5, 0, 0)
 scale .25
}
#declare t_tile=
texture{
 #if (use_textures)
 pigment{p1} 
 finish{Glossy}
 #else
 pigment{bc} 
 #end
}
#declare t_tile_blue=
texture{
  pigment{c_tile_blue} 
  #if (use_normals)
  normal{bumps .1 scale 3}
  normal{granite .05 scale .01}
  #end 
  #if (use_textures)
  finish{Glossy}
  #end
}
#declare ts=15; // tile side
#macro tile(r_tile)
union{
 #if (use_radiosity=2)
 box{-.5,.5
 #else
 object{basic_tile
 #end
  texture{t_tile
   #if (use_normals)
    normal{bumps .1 scale 3 translate 1000*rand(r_tile)}
    normal{granite scale .01}
   #end  }
  scale <1,1,.125>*.99
  rotate (-.5+rand(r_tile))*y
  rotate (-.5+rand(r_tile))*x
 }
 box{-.5,.5 scale <1,1,.11>
  texture{t_white_plastic
  #if (use_normals)
  normal{granite .1 scale .1}
  #end
  }
 }
 scale ts
}
#end
#declare r_tile=seed(676);
#declare nt=room_width/ts;
#declare it=0;
#declare wall_tiles_1=
union{
#while (it<nt)
 object{tile(r_tile)
  translate (-room_width*.5+ts*.5+it*ts)*x
  translate (-room_height*.5+ts*.5)*y
 }
 object{tile(r_tile) 
  translate (-room_width*.5+ts*.5+it*ts)*x
  translate (-room_height*.5+ts*.5+ts*1)*y
 }
 object{tile(r_tile) 
  translate (-room_width*.5+ts*.5+it*ts)*x
  translate (-room_height*.5+ts*.5+ts*2)*y
 }
 object{tile(r_tile) 
  translate (-room_width*.5+ts*.5+it*ts)*x
  translate (-room_height*.5+ts*.5+ts*3)*y
 }
 object{tile(r_tile) 
  translate (-room_width*.5+ts*.5+it*ts)*x
  translate (-room_height*.5+ts*.5+ts*4)*y
 }
 object{tile(r_tile) 
  translate (-room_width*.5+ts*.5+it*ts)*x
  translate (-room_height*.5+ts*.5+ts*5)*y
 }
 object{tile(r_tile) 
  translate (-room_width*.5+ts*.5+it*ts)*x
  translate (-room_height*.5+ts*.5+ts*6)*y
 }
 object{tile(r_tile) 
  translate (-room_width*.5+ts*.5+it*ts)*x
  translate (-room_height*.5+ts*.5+ts*7)*y
 }
 object{tile(r_tile) 
  translate (-room_width*.5+ts*.5+it*ts)*x
  translate (-room_height*.5+ts*.5+ts*8)*y
 }
 cylinder{<-ts*.5,ts*.5,0>,<ts*.5,ts*.5,0>,3 scale <.99,1,.25>
  texture{t_tile_blue translate 100*rand(r_tile)}
  translate (-room_width*.5+ts*.5+it*ts)*x
  translate (-room_height*.5+ts*.5+ts*8+1.51)*y
 }
 #declare it=it+1;
#end
}
#declare nt=room_length/ts;
#declare it=0;
#declare wall_tiles_2=
union{
#while (it<nt)
 object{tile(r_tile) rotate -90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5)*y
 }
 object{tile(r_tile)  rotate -90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*1)*y
 }
 object{tile(r_tile)  rotate -90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*2)*y
 }
 object{tile(r_tile)  rotate -90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*3)*y
 }
 object{tile(r_tile)  rotate -90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*4)*y
 }
 object{tile(r_tile)  rotate -90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*5)*y
 }
 object{tile(r_tile)  rotate -90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*6)*y
 }
 object{tile(r_tile)  rotate -90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*7)*y
 }
 object{tile(r_tile)  rotate -90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*8)*y
 }
 cylinder{<-ts*.5,ts*.5,0>,<ts*.5,ts*.5,0>,3 
  scale <.99,1,.25>  rotate -90*y
  texture{t_tile_blue translate 100*rand(r_tile)}
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*8+1.51)*y
 }
 #declare it=it+1;
#end
}
// window wall
#declare nt=room_length/ts;
#declare it=0;
#declare wall_tiles_w=
union{
#while (it<nt)
 object{tile(r_tile) rotate 90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5)*y
 }
 object{tile(r_tile)  rotate 90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*1)*y
 }
 object{tile(r_tile)  rotate 90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*2)*y
 }
 object{tile(r_tile)  rotate 90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*3)*y
 }
 object{tile(r_tile)  rotate 90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*4)*y
 }
 object{tile(r_tile)  rotate 90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*5)*y
 }
 object{tile(r_tile)  rotate 90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*6)*y
 }
 object{tile(r_tile)  rotate 90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*7)*y
 }
 #if ((-room_length*.5+ts*.5+it*ts)>(win_pos.z+win_width*.5) | (-room_length*.5+ts*.5+it*ts)<(win_pos.z-win_width*.5))
 object{tile(r_tile)  rotate 90*y
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*8)*y
 }
 cylinder{<-ts*.5,ts*.5,0>,<ts*.5,ts*.5,0>,3 
  scale <.99,1,.25>  rotate 90*y
  texture{t_tile_blue translate 100*rand(r_tile)}
  translate (-room_length*.5+ts*.5+it*ts)*z
  translate (-room_height*.5+ts*.5+ts*8+1.51)*y
 }
 #end
 #declare it=it+1;
#end
}
#declare tiles_window=
union{
 cylinder{<-wall_width*.5,ts*.5,0>,<wall_width*.5,ts*.5,0>,3 scale <1,1,.25>
  texture{t_tile_blue translate 100*rand(r_tile)}
  translate (room_width*.5+wall_width*.5)*x
  translate (win_pos.z+win_width*.5)*z
  translate (-room_height*.5+ts*.5+ts*8+1.51)*y
 }
 cylinder{<-wall_width*.5,ts*.5,0>,<wall_width*.5,ts*.5,0>,3 scale <1,1,.25>
  texture{t_tile_blue translate 100*rand(r_tile)}
  translate (room_width*.5+wall_width*.5)*x
  translate (win_pos.z-win_width*.5)*z
  translate (-room_height*.5+ts*.5+ts*8+1.51)*y
 }
 object{tile(r_tile) 
  translate (room_width*.5+wall_width*.35)*x
  translate (win_pos.z+win_width*.5)*z
  translate (-room_height*.5+ts*.5+ts*8)*y
 }
 object{tile(r_tile) 
  translate (room_width*.5+wall_width*.35)*x
  translate (win_pos.z-win_width*.5)*z
  translate (-room_height*.5+ts*.5+ts*8)*y
 }
 object{tile(r_tile) rotate 90*x rotate 90*y
  translate (room_width*.5+wall_width*.35)*x
  translate (win_pos.z+win_width*.5-ts*.5)*z
  translate (-room_height*.5+win_pos.y-win_height*.5-.5)*y
 }
 object{tile(r_tile) rotate 90*x rotate 90*y
  translate (room_width*.5+wall_width*.35)*x
  translate (win_pos.z+win_width*.5-ts*.5-ts*1)*z
  translate (-room_height*.5+win_pos.y-win_height*.5-.5)*y
 }
 object{tile(r_tile) rotate 90*x rotate 90*y
  translate (room_width*.5+wall_width*.35)*x
  translate (win_pos.z+win_width*.5-ts*.5-ts*2)*z
  translate (-room_height*.5+win_pos.y-win_height*.5-.5)*y
 }
 object{tile(r_tile) rotate 90*x rotate 90*y
  translate (room_width*.5+wall_width*.35)*x
  translate (win_pos.z+win_width*.5-ts*.5-ts*3)*z
  translate (-room_height*.5+win_pos.y-win_height*.5-.5)*y
 }
 object{tile(r_tile) rotate 90*x rotate 90*y
  translate (room_width*.5+wall_width*.35)*x
  translate (win_pos.z+win_width*.5-ts*.5-ts*4)*z
  translate (-room_height*.5+win_pos.y-win_height*.5-.5)*y
 }
}



#declare kitchen_room=
union{
 // front wall
 union{
  box{-.5,.5 scale <room_width,room_height,wall_width>}
  object{wall_tiles_1 translate -wall_width*.51*z}
  translate (room_length*.5+wall_width*.5)*z
 }
 // back wall
 difference{
  box{-.5,.5 scale <room_width,room_height,wall_width>}
  box{-.5,.5 scale <door_width,door_height,wall_width*1.1> 
   translate <0,-room_height*.5+door_height*.5,0>
  }
  translate -(room_length*.5+wall_width*.5)*z
 }
 // right wall
 difference{
  box{-.5,.5 scale <wall_width,room_height,room_length>
   translate (room_width*.5+wall_width*.5)*x
  }
  box{-.5,.5 scale <wall_width*1.1,win_height,win_width> 
   translate <room_width*.5+wall_width*.5,-room_height*.5+win_pos.y,win_pos.z>
  }
 }
 object{wall_tiles_w translate -wall_width*.51*x
   translate (room_width*.5+wall_width*.5)*x
 }
 object{tiles_window}
 // left wall
 box{-.5,.5 scale <wall_width,room_height,room_length>
  translate -(room_width*.5+wall_width*.5)*x
 }
 object{wall_tiles_2 translate wall_width*.51*x
   translate -(room_width*.5+wall_width*.5)*x
 }
 // ceil
 #if (camera_select<99)
 box{-.5,.5 scale <room_width,wall_width,room_length>
  translate (room_height*.5+wall_width*.5)*y
 }
 #end
 // other room / corridor
 box{-.5,.5 scale <room_width,room_height,wall_width>
  translate (room_length*.5+wall_width*.5)*3*z
 }
 // left wall
 box{-.5,.5 scale <wall_width,room_height,room_length>
  translate -(room_width*.5+wall_width*.5)*x
  translate -(room_length*.5+wall_width*.5)*2*z
 }
 // right wall
 box{-.5,.5 scale <wall_width,room_height,room_length>
  translate (room_width*.5+wall_width*.5)*x
  translate -(room_length*.5+wall_width*.5)*2*z
 }
 // rear wall
 difference{
  box{-.5,.5 scale <room_width,room_height,wall_width>}
  box{-.5,.5 scale <door_width,door_height,wall_width*1.1> 
   translate <0,-room_height*.5+door_height*.5,0>
  }
  translate -(room_length*.5+wall_width*.5)*z
  translate -(room_length*.5+wall_width*.5)*2*z
 }
 // ceil
 #if (camera_select<99)
 box{-.5,.5 scale <room_width,wall_width,room_length>
  translate (room_height*.5+wall_width*.5)*y
  translate -(room_length*.5+wall_width*.5)*2*z
 }
 #end
 // ceil border
height_field{
 png "hf_ceil-border"
 water_level 0.1
 translate -.5
 rotate -90*x
 scale <5,5,room_length>
 translate <-2.5,-2.5,0>
  translate (room_height*.5)*y
  translate (room_width*.5)*x
 }
 translate room_height*.5*y
 texture{t_wall_paint}
}

