/*

  The Kitchen - Jaime Vives Piqueres 2004-2005

  Entry for the POVCOMP 2004

  i_textures.inc : dual version of the scene textures for each pass

*/

// *** comon pigments ***
// curtains
#declare c1=White;
#declare c2=White;
#declare p_cloth1=SeaGreen;
#declare p_cloth2=c_tile_blue;

#if (use_textures) 

 // *** FINAL TEXTURES ***

 // dirt layers
 #declare t_kdirty=
 texture{
  pigment{
   planar
   warp{turbulence 1 lambda 3}
   color_map{
    [0.0 rgbt 1]
    [0.95 Orange*.1 transmit .95]
    [1.0 Orange*.1 transmit .85]
   }
   scale <4,80,4> translate 40*y
   warp{turbulence 1 lambda 3}
  }
 }

 #declare t_wdirty=
 texture{
  pigment{
   bozo
   warp{turbulence 1 lambda 3}
   color_map{
    [0.0 rgbt 1]
    [1.0 Orange*.1 transmit .85]
   }
   scale 10
  }
 }

 // walss paint
 #declare t_white_paint=
 texture{
  pigment{rgb ReflectiveSpectrum(RS_White_Paint_1)}
  finish{diffuse 1}
 }
 #declare t_wall_paint=
 texture{
  pigment{
   image_map{jpeg "im_wallpaint.jpg"} 
   translate -.5 rotate 90*y
   scale <room_length,room_height,room_length> 
   warp{turbulence pi lambda 3}
  }
  finish{diffuse 1}
 }
 texture{t_kdirty translate (250-80)*y}

 // floor tiles
 #declare t_floor=
 texture{
  pigment{checker color White color Gray10 scale 25 rotate 45*y}
  finish{reflection{.01,.1} diffuse .9}
 }

 // furniture woods
 #declare t_wood_furn_ll=
  texture {  
    pigment{ P_WoodGrain1A 
     color_map { 
      M_Wood7A 
     }
     rotate 90*y
     warp {
      black_hole <0.3, 0.3, 0>, 0.25
      strength 3
      inverse
      repeat <0.7, 1, 1>
      turbulence <0.15, 0.4, 1>
     }
     rotate -90*y
     warp {
      black_hole <0.3, 0.3, 0>, 0.25
      strength 3
      inverse
      repeat <0.7, 1, 1>
      turbulence <0.15, 0.4, 1>
     }
    }
    rotate 1
    scale 10
  }
 #declare t_wood_furn_ul=
  texture {  
    pigment{ P_WoodGrain1B 
     color_map { 
      M_Wood7B 
     }
    }
    #if (use_normals)
    normal{wood .2 turbulence 0.04 lambda 3 octaves 3 scale <0.05, .05, 1>}
    #end
    finish{Phong_Shiny reflection{.02,.2 falloff 5}}
    scale 10
  }
 #declare t_wood_furn=
  texture{t_wood_furn_ll}
  texture{t_wood_furn_ul}
  texture{
   pigment{
    bumps turbulence 1
    color_map{
     [0 Tan*.1+Orange*.2 transmit .1]
     [1 Tan*.1+Orange*.2 transmit .9]
    }
    scale <1,1,10>*40
    translate 2423
   }
  }

 // cutting board wood
 #declare t_wood_board=
 texture{
  T_Wood7 finish{ambient 0}
 }

 // chairs wood
 #declare t_wood_chair=
 texture{T_Wood8
  #if (use_normals)
  normal{granite .01 scale .1}
  #end
  finish{Glossy}
 }

 // counter-top marble
 #declare t_marble=
 texture{T_Stone31 scale 2
  finish{reflection{.01,.67 falloff 5} diffuse .33 ambient 0}
 }
 texture{t_wdirty}

 // chrome metal
 #declare t_chrome=
 texture{Polished_Chrome 
  #if (use_normals)
  normal{granite .01 scale .01}
  #end
  finish{diffuse .1 ambient 0}
 }

 // steel
 #declare t_steel=
 texture{T_Chrome_3B
  #if (use_normals)
  normal{granite .05 scale .01}
  #end
  finish{diffuse .1 ambient 0}
 }

 // inox
 #declare t_inox=
 texture{T_Chrome_5B
  #if (use_normals)
  normal{granite .05 scale .01}
  #end
  finish{diffuse .1 ambient 0}
 }

 // pot inox with dirt
 #declare t_inox_olla=
 texture{t_inox}
 texture{
  pigment{
   gradient y
   color_map{
    [0.0 Black]
    [1.0 rgbt 1]
   }
   turbulence <1,.01,1> lambda 3
   translate -.5*y
   scale 1.6
   translate .05*y
  }
 }

 // plastics 
 #declare t_white_plastic=
 texture{
  pigment{rgb ReflectiveSpectrum(RS_White_Shiny_Plastic)}
  #if (use_normals)
  normal{granite .01 scale .2}
  #end
  finish{Phong_Shiny reflection{.05,.2} diffuse .9}
 }
 texture{t_kdirty}

 #declare t_palegreen_plastic=
 texture{
  pigment{Green*.5+Gray}
  #if (use_normals)
  normal{granite .01 scale .2}
  #end
  finish{Shiny reflection{.05,.2} diffuse .8}
 }

 #declare t_orange_plastic=
 texture{
  pigment{Orange}
  finish{Shiny reflection{.05,.2} diffuse .8}
 }

 #declare t_black_plastic=
 texture{
  pigment{Gray10*.5}
  #if (use_normals)
  normal{granite .01 scale .02}
  #end
  finish{Shiny reflection{.05,.2} diffuse .8}
 }

 #declare t_red_plastic=
 texture{
  pigment{Red}
  finish{Shiny reflection{.05,.2} diffuse .8}
 }

 #declare t_blue_plastic=
 texture{
  pigment{Blue*.5+Gray20+Green*.1}
  finish{Shiny reflection{.05,.2} diffuse .8}
 }

 #declare t_green_plastic=
 texture{
  pigment{SeaGreen}
  finish{Shiny reflection{.05,.2} diffuse .8}
 }

 // plates ceramic
 #declare t_ceramic=
 texture{
  pigment{Tan*.8+Gray10}
  finish{reflection{.05,.2} diffuse 1}
 }

 // water & glasses
 #declare t_water=
 texture{pigment{White}}

 #declare t_wglass=
 texture{
  #if (use_daylight)
  pigment{White} 
  finish{diffuse 0 ambient 40}
  #else
  Mirror
  #end
 }

 // window
 #declare t_wood_win=
 t_wood_furn
 #declare t_wh_metal=
 texture{pigment{Bronze} finish{F_MetalA}}

 #declare t_aluminum=texture{Aluminum finish{ambient 0}}
 #declare t_aluminum_cafe=
 texture{t_aluminum}
 texture{
  pigment{
   gradient y cubic_wave
   color_map{
    [0.0 Black]
    [1.0 rgbt 1]
   }
   turbulence <1,.01,1> lambda 3
   scale 5.3
   translate 0*y
  }
 }

 // curtains, towel & tablecloth
 #declare r_curt=seed(42);
 #declare TILE_WARP_SIZE=3;
 #declare TILE_WARP_ANGLE=45;
 #declare c_ktc_blue=rgb c_tile_blue+Gray10 transmit .15;
 #declare c_ktc_green=rgb c_tile_green+Green*.1 transmit .15;
 #declare c_ktc_orange=rgb c_tile_orange+Red*.1 transmit .15;
 #declare c_ktc_white=rgbt <1,1,1,.15>;
 #declare f_curtain=function{sin(abs(x))+cos(abs(z))}
 #declare a_col2=array[2] {c_ktc_blue,c_ktc_green}
 #declare a_col3=array[3] {c_ktc_orange,c_ktc_blue,c_ktc_green}
 #declare dspx=1000*rand(r_curt);
 #declare dspz=1000*rand(r_curt);
 #declare p_kitchen_tablecloth=
 pigment{
  p_tile( function{f_curtain(x*.5+dspx,y*.5+dspz,z)}, c_ktc_white, c_ktc_white, a_col2, .67, 0, 0) scale .0025
  warp{planar}
 }
 #declare t_curtain_pattern=
 texture{
  pigment{
   p_kitchen_tablecloth 
  }
  finish{diffuse 1}
  normal{quilted .1*use_normals scale .001}
  scale 4
 }
 #declare t_curtain=
 texture{
  uv_mapping t_curtain_pattern
 }

 #declare t_ktowel=
 texture{
  uv_mapping t_curtain_pattern scale 1.5
 }

#declare t_cloth=
 texture{
  pigment{
   p_kitchen_tablecloth
  }
  finish{diffuse .9}
  normal{quilted .2*use_normals scale .000125}
 }

 #declare t_table_cloth =
 texture{
  uv_mapping t_cloth
 }

 // fruits
 #declare t_platano=
 texture{
  pigment{
   uv_mapping image_map{tga "im_platano-uv"}
  }
 }

 // cleaning product label
 #declare t_cleaning_label=
 texture{
  pigment{image_map{png "im_cleaning" map_type 2} rotate 45*y}
  scale 1.1
  translate -.4*y
 }

 // spices jar label
 #declare t_spices_label=
 texture{
  pigment{image_map{png "im_splabel" map_type 2} rotate 45*y}
  scale 1.33
  translate -.6*y
 }

 // water bottle
 #declare t_wb_tap=t_white_plastic
 #declare t_wb_label=
 texture{
  pigment{image_map{png "im_wblabel" map_type 2}}
  scale .45
  translate .2*y
 }
 #declare t_wb_pet=texture{T_Glass4 finish{ambient 0}}

 // bit pots tap
 #declare t_pot_tap1=
 texture{
  Brass_Metal
  finish{ambient 0}
 }

 // beer can
 #declare t_can=
 texture{
  pigment{
   image_map{
    png "im_lata01"
    interpolate 2
    map_type 2
   }
  }
  normal{bumps 0.1 scale 4}
  finish{Shiny metallic reflection 0.1 ambient 0}
 }

  // kitchen 
  #declare t_color1=
  texture{t_white_plastic}
  texture{t_kdirty} 
  #declare t_color2=
  texture{t_white_plastic}
  texture{t_kdirty} 

  // frying pan
  #declare t_teflon=texture{pigment{DarkGreen*.1} 
   finish{Dull metallic reflection{.01,.1}}
  }
  #declare t_mango=t_black_plastic
  #declare t_fondo=
  texture{
   Copper_Metal finish {ambient 0}
   #if (use_normals)
   normal{onion scale .1}
   #end
  }

  // paper roll
  #declare t_kpaper=
  texture{pigment{image_map{png "im_kpaper" map_type 2} scale <6,7,6>*.9/6 translate .5*y}
   #if (use_normals)
   normal{quilted scale .1}
   #end
  }
  #declare t_cardboard=
  texture{pigment{Tan*.5+Gray*.5}}

 // vegetables on the pots
 #declare t_lentejas=
 texture{
  pigment{
   crackle turbulence 1
   color_map{
    [0.0 DarkTan]
    [1.0 DarkTan*.1]
   }
  } 
  #if (use_normals)
  normal{granite 10}
  #end
  finish{Phong_Shiny}
 }
 #declare t_garbanzos=
 texture{
  pigment{
   crackle scale .1 turbulence 1
   color_map{
    [0.0 Flesh]
    [1.0 Orange*.1+Gray10]
   }
  }
  finish{Phong_Shiny}
  #if (use_normals)
  normal{granite 10 scale 2}
  #end
 }

  // blue vases
  #declare t_blue_vase=
  texture{pigment{c_tile_blue*.5+Blue*.1+Violet*.1}
   finish{reflection{.1,.5 falloff 5} ambient 0}
  }

// tomatos
#declare t_tm_leafs=
texture{pigment{Green*.4+Gold*.2+Gray10}}
#declare t_tm_flesh=
texture{
 pigment{
  bumps
  color_map{
   [0 OrangeRed]
   [0.5 Red*.75+OrangeRed*.25]
   [1 ForestGreen]
  }
 }
 finish{Phong_Glossy}
 #if (use_normals)
 normal{granite scale .5}
 #end
}
#declare t_tm_iflesh=
texture{
 pigment{
  granite scale 1 turbulence 1
  color_map{
   [0 rgbt 1]
   [0.5 Red]
   [0.5 Orange]
   [1 ForestGreen]
  }
 }
 finish{Glossy}
 #if (use_normals)
 normal{granite scale .5}
 #end
}

// cleaning products
#declare t_mp_tap=t_white_plastic
#declare t_mp_plastic=t_palegreen_plastic
#declare t_mp_label=
texture{
 pigment{image_map{jpeg "im_mrpover.jpg"} translate -.5 rotate 180*y scale <1,1.6,1> translate .1*y}
}
#declare t_plastico_blanco=t_white_plastic

// cereals box, cereals, milk
#declare t_board=texture{pigment{Tan}}
#declare t_sidex=
texture{
 pigment{image_map{jpeg "im_cerealbox2.jpg"}}
 translate -.5 scale <.5,2.5,.5>
 rotate -90*y
}
#declare t_sidez=
texture{
 pigment{image_map{jpeg "im_cerealbox1.jpg"}}
 translate -.5 scale <2,2.5,2>
}
#declare t_sidez_back=
texture{
 pigment{image_map{jpeg "im_cerealbox1.jpg"}}
 translate -.5 scale <2,2.5,2>
}
#declare t_tap=t_board
#declare t_milk=
texture{
 pigment{rgb 1 transmit .9}
 #if (use_normals)
 normal{bumps .2 scale 1}
 #end
 finish{reflection{.01,.2} diffuse .9 ambient .001}
}

#else 

 // *** SIMPLE VERSIONS FOR RADIOSITY SAVING ***

 #declare t_white_paint=
 texture{
  pigment{rgb ReflectiveSpectrum(RS_White_Paint_1)}
  finish{diffuse 1}
 }

 #declare t_wall_paint=
 texture{
  pigment{rgb ReflectiveSpectrum(RS_White_Paint_1)}
  finish{diffuse 1}
 }

 #declare t_floor=texture{pigment{Gray}}

 #declare t_wood_furn=texture{pigment{Tan}}

 #declare t_wood_board=texture{pigment{Tan*.5+Gold*.5}}

 #declare t_marble=texture{pigment{Flesh}}

 #declare t_chrome=texture{pigment{Gray}}
 #declare t_steel=texture{pigment{Gray}}
 #declare t_inox=texture{pigment{Gray}}
 #declare t_inox_olla=t_inox

 #declare t_ceramic=
 texture{
  pigment{Wheat}
 }

 #declare t_white_plastic=
 texture{
  pigment{rgb ReflectiveSpectrum(RS_White_Shiny_Plastic)}
  finish{diffuse .9} 
 }

 #declare t_palegreen_plastic=
 texture{
  pigment{Green*.5+Gray}
  finish{diffuse .8}
 }

 #declare t_green_plastic=
 texture{
  pigment{SeaGreen}
  finish{diffuse .8}
 }

 #declare t_black_plastic=
 texture{
  pigment{Gray10}
  finish{diffuse .8}
 }

 #declare t_red_plastic=
 texture{
  pigment{Red}
  finish{diffuse .8}
 }

 #declare t_blue_plastic=
 texture{
  pigment{Blue*.5+Gray20+Green*.1}
  finish{diffuse .8}
 }

 #declare t_orange_plastic=
 texture{
  pigment{Orange}
  finish{diffuse .8}
 }

 #declare t_water=
 texture{pigment{White}}

 #declare t_wglass=
 texture{
  pigment{White #if(use_daylight) transmit 1 #end }
  finish{diffuse 0}
 }

 #declare t_wood_win=
 texture{pigment{White}}
 #declare t_wh_metal=
 texture{pigment{Bronze}}

 #declare t_aluminum=
 texture{pigment{Gray}}
 #declare t_aluminum_cafe=
 texture{pigment{Gray}}

 #declare t_curtain=
 texture{
  pigment{White}
 }

 #declare t_ktowel=
 texture{
  pigment{White}
 }

 #declare t_table_cloth=
 texture{
  pigment{
   gradient x
   color_map{
    [0.0 p_cloth1]
    [0.5 p_cloth1]
    [0.5 White]
    [1.0 White]
   }
   scale .04
  }
  finish{diffuse 1}
 }

 #declare t_platano=
 texture{
  pigment{Yellow*.6+Orange*.4}
 }

 #declare t_cleaning_label=texture{pigment{White}}

 #declare t_spices_label=texture{pigment{White}}

 #declare t_wood_chair=
 texture{pigment{Flesh}}

 #declare t_wb_tap=t_white_plastic
 #declare t_wb_label=texture{pigment{White}}
 #declare t_wb_pet=texture{pigment{White} finish{diffuse 1}}

 #declare t_pot_tap1=texture{pigment{Brass}}

 #declare t_can=texture{pigment{Gray}}

 #declare t_color1=
 texture{t_white_plastic}
 #declare t_color2=
 texture{t_white_plastic}

 #declare t_teflon=texture{pigment{DarkGreen*.1}}
 #declare t_mango=t_black_plastic
 #declare t_fondo=texture{pigment{Copper}}

 #declare t_kpaper=texture{t_white_paint}
 #declare t_cardboard=texture{pigment{Tan*.5+Gray*.5}}

 #declare t_lentejas=texture{pigment{DarkTan}}
 #declare t_garbanzos=texture{pigment{Flesh}}

 #declare t_blue_vase=
 texture{pigment{c_tile_blue*.5+Blue*.1+Violet*.1}
  #if (use_textures)
  finish{reflection{.1,.5 falloff 5} ambient 0}
  #end
 }

#declare t_tm_leafs=texture{pigment{Green*.4+Gold*.2+Gray10}}
#declare t_tm_flesh=texture{pigment{OrangeRed}}
#declare t_tm_iflesh=texture{pigment{OrangeRed}}

#declare t_mp_tap=t_white_plastic
#declare t_mp_plastic=t_palegreen_plastic
#declare t_mp_label=texture{pigment{Gray}}
#declare t_plastico_blanco=t_white_plastic

#declare t_board=texture{pigment{Tan}}
#declare t_sidex=texture{pigment{Gray}}
#declare t_sidez=texture{pigment{Gray}}
#declare t_sidez_back=texture{pigment{Gray}}
#declare t_tap=t_board
#declare t_milk=texture{pigment{rgb 1}}

#end
